% Matlab Program 10-7 : Digital PIDA control for the 3rd order plant
tz = input('Digital sampling time tz = ');
% Continuous plant transfer function
ng = 1;
dg = [1 1 0 0];
% PIDA controller parameters
K= 35.3; Ka = 35.3;
a = 1.9090+1.9418*i; b = 1.9090-1.9418*i; z = 2.0242;
% Conversion to digital PIDA controller 
Kp = K*(z*(a+b)+a*b);
Kd = K*(a+b+z);
Ki = K*a*b*z;
A = tz^2 *Kp + tz^3 * Ki/2 + tz*Kd + Ka;
B = tz^3 * Ki/2 - tz^2 * Kp - 2*tz*Kd - 3*Ka;
dnc1 = [A B (tz*Kd+3*Ka) -Ka];
ddc1 = tz^2 *[1 -1 0 0];
nc = K*1000*1000*conv(conv([1 a],[1 b]),[1 z]);
dc = conv(conv([1 1000],[1 1000]),[1 0]);
nopen2 = conv(nc,ng);
dopen2 = conv(dc,dg);
% Convert continuous to discrete
[dng,ddg] = c2dm(ng,dg,tz,'zoh');
[dno2,ddo2] = c2dm(nopen2,dopen2,tz,'zoh');
% Open loop transfer function
[nopen1,dopen1] = series(dnc1,ddc1,dng,ddg);
% Closed loop transfer function
[nclose1,dclose1] = cloop(nopen1,dopen1,-1);
[nclose2,dclose2] = cloop(dno2,ddo2,-1);
% Step response
y1 = filter(nclose1,dclose1,ones(1,50));
y2 = filter(nclose2,dclose2,ones(1,50));
title('Step response')
% Plot step responses
k = [1:50];
plot(k,y1,'o',k,y2,'-')
legend('Digital PIDA','MATLAB Conversion')
xlabel('No. of samples, k')
ylabel('y(k)')
title('Step response')
grid

