%MATLAB Program 2-16 :  Speed control
% Motor parameters
Ra = 1; Ki = 2; J = 2; f = 0.5; Kb = 0.1; Kt = 1;
Ka = input('Controller gain Ka = ');
% Open loop transfer function R(s) to Y(s)
rynopen = Ki; rydopen = [Ra*J Ra*f+Ki*Kb];
% Open loop transfer function D(s) to Y(s)
dynopen = -Ra;dydopen = [Ra*J Ra*f+Ki*Kb];
% Closed loop transfer function R(s) to Y(s)
rynclose = Ka*Ki; dynclose = -Ra;
rydclose = [Ra*J Ra*f+Ki*Kb+Ka*Ki*Kt];
% Closed loop transfer function D(s) to Y(s)
dynclose = -Ra; dydclose = [Ra*J Ra*f+Ki*Kb+Ka*Ki*Kt];
%Step response due to R(s)
t = [0:0.1:10];
ryopen = step(rynopen,rydopen,t);
ryclose = step(rynclose,rydclose,t);
subplot(211)
plot(t,ryopen,'--',t,ryclose)
grid
legend('Open loop','Closed loop')
title('Step responses due to R(s)')
xlabel('t (sec)')
ylabel('Output y(t)')
pause
% Step response due to disturbance D(s)
dyopen = step(dynopen,rydopen,t);
dyclose = step(dynclose, rydclose,t);
subplot(212)
plot(t,dyopen,'--',t,dyclose)
grid
legend('Open loop','Closed loop')
title('Step responses due to D(s)') 
xlabel('t (sec)')
ylabel('Output y(t)')
pause

% Steady state error
erropen = 1- ryopen;
errclose = 1- ryclose;
subplot(111)
plot(t,erropen,'--',t,errclose);
xlabel('t (sec)')
ylabel('Output error e(t)')
legend('Open loop','Closed loop')
grid

