%MATLAB Program  3-2 : Step response parameters

zeta = [0.0:0.01:0.95];                     % damping
wn = 4;                                     % natural frequency
Mp = 1+exp(-zeta*pi./sqrt(1-zeta.^2));      % max
PO = 100*exp(-zeta*pi./sqrt(1-zeta.^2));    % percent overshoot
Ts = zeta*wn./4;                            % settlling time
tpeak = pi./(wn*sqrt(1-zeta.^2));           % peak time
plot(zeta,PO)
grid
xlabel('zeta')
ylabel('P.O')
title('Relationship between zeta and P.O')
pause
plot(zeta,Ts,'--',zeta,tpeak)
grid
legend('Settling time','Peak time')
xlabel('zeta')
ylabel('t (sec)')
title('Relationship between zeta and Ts, and tpeak')
