% MATLAB Program 6-6 : Lead controller with prefilter

% Plant
ng = 1;
dg = [1 0 0];
% Lead controller
nlead = 8.1*[1 1];
dlead = [1 3.6];
% Open loop
nopen = conv(ng,nlead);
dopen = conv(dg,dlead);
% Prefilter
nfilter = 1;
dfilter = [1 1];
% Closed loop
[nclose,dclose] = cloop(nopen,dopen,-1);
% Step response
t = [0:0.1:10];
y1 = step(nclose,dclose,t);
y2 = step(conv(nfilter,nclose),conv(dfilter,dclose),t);
plot(t,y1,t,y2,'--');
legend('No Prefilter','With a Prefilter')
grid
title('Step response with a lead controller and a prefilter')
xlabel('time (s)')
ylabel('y(t)')
