% MATLAB Program 6-8 : Lag controller with a prefilter

% Plant 
ng = 1;
dg = conv([1 0.5],[1 2]);
% Lag controller
nlag = 2*[1 0.75];
dlag = [1 0.1];
% Open loop
nopen = conv(ng,nlag);
dopen = conv(dg,dlag);
% Prefilter
nfilter = 0.75;
dfilter = [1 0.75];
% Closed loop
[nclose,dclose] = cloop(nopen,dopen,-1);
% Step response
t = [0:0.1:10];
y1 = step(nclose,dclose,t);
y2 = step(conv(nfilter,nclose),conv(dfilter,dclose),t);
plot(t,y1,t,y2,'--');
legend('No Prefilter','With a Prefilter')
grid
title('Step response with a lag controller and a prefilter')
xlabel('time (s)')
ylabel('y(t)')
