%MATLAB Program 6-8 : Design of lead-lag controller for a third order plant.
ng = 1;                                       % Plant
dg = conv([1 0],conv([1 1],[1 7]));
nlead1 = [ 1 1.3];                            % 
dlead1 = [1 32.5];
nlag2 = [ 1 1.5];
dlead2 = [1 37.5];

%Root locus plot with a lead controller
ngl1 = conv(ng,nlead1);
dgl1 = conv(dg,dlead1);
ngl2 = conv(ng,nlead2);
dgl2 = conv(dg,dlead2);
rlocus(ngl1,dgl1);
pause;
k1 = 630.6011;
k2 = 730.75;
nlag1 = [1 0.1];
dlag1 = [1 0.018];
nlag2 = [1 0.1];
dlag2 = [1 0.021];
nopen1 = k1*conv(ngl1,nlag1);
dopen1 = conv(dgl1,dlag1);
nopen2 = k2*conv(ngl2,nlag2);
dopen2 = conv(dgl2,dlag2);
[nclose1,dclose1] = cloop(nopen1,dopen1,-1);
[nclose2,dclose2] = cloop(nopen2,dopen2,-1);
t = [0:0.1:6];
y1 = step(nclose1,dclose1,t);
plot(t,y1)
pause;

%Add a prefilter
nfilter1 = 1.3;
dfilter1 = [1 1.3];
y2 = step(conv(nfilter1,nclose1),conv(dfilter1,dclose1),t);
plot(t,y1,t,y2,'--');
pause;

%Another prefilter
nfilter2 = 1.8;
dfilter2 = [1 1.8];
y3 = step(conv(nfilter2,nclose1),conv(dfilter2,dclose1),t);
pause;

%Another controller design
nfilter3 = 1.5;
dfilter3 = [1 1.5];
y4 = step(conv(nfilter3,nclose2),conv(dfilter3,dclose2),t);
plot(t,y1,t,y2,'--',t,y3,'-.',t,y4,':');
legend('No Prefilter','With a C1(s) and a P1(s)', ...
'With a C1(s) and a P2(s)','With a C2(s) and a P3(s)')
grid
title('Step response with  Lead-lag controllers and prefilters')
xlabel('t (sec)')
ylabel('Output y(t)')


