% MATLAB Program 6-9 :   PI controller with prefilter

% Plant
ng = 1;
dg = conv([1 0.5],[1 2]);
% PI controller
nlag = 8.1*[1 0.75];
dlag = [1 0];
% Open loop
nopen = conv(ng,nlag);
dopen = conv(dg,dlag);
% Prefilter
nfilter1 = 0.75;
dfilter1 = [1 0.75];
% Closed loop
[nclose,dclose] = cloop(nopen,dopen,-1);
% Step response
t = [0:0.1:10];
y1 = step(nclose,dclose,t);
y2 = step(conv(nfilter1,nclose),conv(dfilter1,dclose),t);
plot(t,y1,t,y2,'--');
legend('No Prefilter','With a Prefilter')
grid
title('Step response with a PI controller and a prefilter')
xlabel('time (s)')
ylabel('y(t)')
pause;
% Another prefilter design
nfilter2 = 1.2;
dfilter2 = [1 1.2];
y3 = step(conv(nfilter2,nclose),conv(dfilter2,dclose),t);
plot(t,y1,t,y2,'--',t,y3,':');
legend('No Prefilter','With a Prefilter 1', 'With a Prefilter 2')
grid
title('Step response with a PI controller and a prefilter')
xlabel('time (s)')
ylabel('y(t)')

