% MATLAB Program 7-13 : lead controller design
% transfer function
ng = 10;
dg = [1 0 0 ];
% Bode
w = logspace(-1,2,100);
[umag,uph] = bode(ng,dg,w);
umag = 20*log10(umag);
nc = 6*[1 2];
dc = [1 12];
ngc = conv(ng,nc);
dgc = conv(dg,dc);
[cmag,cph] = bode(ngc,dgc,w);
cmag = 20*log10(cmag);
subplot(211)
semilogx(w,umag,'--',w,cmag)
grid
legend('Uncom','Com')
ylabel('Gain (dB)')
subplot(212)
semilogx(w,uph,'--',w,cph)
axis([0.1 100 -200 -120])
grid
ylabel('Phase (deg)')
xlabel('Frequency (rad/sec)')
pause;
subplot(111)
[nclose,dclose] = cloop(ngc,dgc,-1);
% Step response
t = [0:0.1:3];
y = step(nclose,dclose,t);
plot(t,y)
grid
title('Step response after lead compensation')
xlabel('time (s)')
ylabel('Output y(t)');
