% MATLAB Program 7-14 : Lag controller design 

% Transfer function
ng = 40;
dg = conv([1 0],[1 2]);
% Bode
w = logspace(-1,2,100);
[umag,uph] = bode(ng,dg,w);
umag = 20*log10(umag);
nc = 0.015/0.15*[1 0.15];
dc = [1 0.015];
ngc = conv(ng,nc);
dgc = conv(dg,dc);
[cmag,cph] = bode(ngc,dgc,w);
cmag = 20*log10(cmag);
subplot(211)
semilogx(w,umag,'--',w,cmag)
grid
legend('Uncom','Com')
ylabel('Gain (dB)')
subplot(212)
semilogx(w,uph,'--',w,cph)
grid
ylabel('Phase (deg)')
xlabel('Frequency (rad/sec)')
pause;
subplot(111)
[nclose,dclose] = cloop(ngc,dgc,-1);
% Step response
t = [0:0.1:6];
y = step(nclose,dclose,t);
plot(t,y)
grid
title('Step response after lag compensation')
xlabel('time (s)')
ylabel('y(t)');
