%MATLAB Program 9-1 : Lead-lag controller design for Type 0

K = input('Controller gains K = ');
% Plant transfer function
ng = 1;
dg = conv([1 1],[1 2]);
% Controller transfer function
nc = K*conv([1 2.2639],[1 2.4661]);
dc = conv([1 42.9],[1 0.3920]);
% Prefilter transfer function
np = 2.2639;
dp = [1 2.2639];
% Open loop transfer function G(s)C(s)
ngc = conv(ng,nc);
dgc = conv(dg,dc);
% Closed loop transfer function T(s) = 1/(1+GC(s))
[nclose,dclose] = cloop(ngc,dgc,-1);
% Transfer function with prefilter 
pnclose = conv(np,nclose);
pdclose = conv(dp,dclose);
% Step response
t = [0:0.1:4];
y1 = step(nclose,dclose,t);
y2 = step(pnclose,pdclose,t);
plot(t,y1,'--',t,y2)
grid
legend('Without prefilter','With prefilter')
xlabel('time (s)')
ylabel(' y(t)')
title('Step response of 1/(s+1)(s+2) with a lead-lag controller')

