% MATLAB Program 9-3 : Lead-lag controller for Type 2
K = input('Controller gains K = ');
% Plant transfer function
ng = 1;
dg = [1 0 0];
% Controller transfer function
nc = K*conv([1 1.511],[1 1.511]);
dc = conv([1 45.5241],[1 0.7759]);
% Prefilter transfer function
np1 = 1.511;
dp1 = [1 1.511];
np2 = 2.0;
dp2 = [1 2.0];
% Open loop transfer function G(s)C(s)
ngc = conv(ng,nc);
dgc = conv(dg,dc);
% Closed loop transfer function T(s) = 1/(1+GC(s))
[nclose,dclose] = cloop(ngc,dgc,-1);
% Transfer function with prefilter 
pnclose1 = conv(np1,nclose);
pdclose1 = conv(dp1,dclose);
pnclose2 = conv(np2,nclose);
pdclose2 = conv(dp2,dclose);
% Step response
t = [0:0.1:4];
y1 = step(nclose,dclose,t);
y2 = step(pnclose1,pdclose1,t);
y3 = step(pnclose2,pdclose2,t);
plot(t,y1,'+',t,y2,'o',t,y3,'*')
grid
legend('Without prefilter','With prefilter 1','With prefilter 2')
xlabel('time (s)')
ylabel(' y(t)')
title('Step response of 1/s^2 with a lead-lag controller')

