%MATLAB Program 9-4 : Lead-lag controller for 3rd order plant
K = input('Controller gains K = ');
% Plant transfer function
ng = 1;
dg = conv([1 0],conv([1 1],[1 7]));
% Controller transfer function
nc = K*conv([1 1.0897],[1 1.0897]);
dc = conv([1 39.4585],[1 0.1699]);
% Prefilter transfer function
np1 = 1.0897;
dp1 = [1 1.0897];
np2 = 1.2;
dp2 = [1 1.2];
% Open loop transfer function G(s)C(s)
ngc = conv(ng,nc);
dgc = conv(dg,dc);
% Closed loop transfer function T(s) = 1/(1+GC(s))
[nclose,dclose] = cloop(ngc,dgc,-1);
% Transfer function with prefilter 1 
pnclose1 = conv(np1,nclose);
pdclose1 = conv(dp1,dclose);
% Transfer function with prefilter 2 
pnclose2 = conv(np2,nclose);
pdclose2 = conv(dp2,dclose);
% Step response
t = [0:0.1:4];
y1 = step(nclose,dclose,t);
y2 = step(pnclose1,pdclose1,t);
y3 = step(pnclose2,pdclose2,t);
plot(t,y1,':',t,y2,'-.',t,y3)
grid
legend('Without prefilter','With prefilter 1', 'With prefilter 2')
xlabel('time (s)')
ylabel('y(t)')
title('Step response of 1/s(s+1)(s+7) with a lead-lag controller')

